org.apache.xalan.xsltc.dom

## Class MultiValuedNodeHeapIterator

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMAxisIteratorBase
  - - org.apache.xalan.xsltc.dom.MultiValuedNodeHeapIterator

All Implemented Interfaces:
  java.lang.Cloneable, DTMAxisIterator

Direct Known Subclasses:
  KeyIndex.KeyIndexIterator, UnionIterator

    public abstract class MultiValuedNodeHeapIterator
    extends DTMAxisIteratorBase

`MultiValuedNodeHeapIterator` takes a set of multi-valued heap nodes and produces a merged NodeSet in document order with duplicates removed.

Each multi-valued heap node (which might be a `DTMAxisIterator`, but that's not necessary) generates DTM node handles in document order. The class maintains the multi-valued heap nodes in a heap, not surprisingly, sorted by the next DTM node handle available form the heap node.

After a DTM node is pulled from the heap node that's at the top of the heap, the heap node is advanced to the next DTM node handle it makes available, and the heap nature of the heap is restored to ensure the next DTM node handle pulled is next in document order overall.

Author:
  Jacek Ambroziak, Santiago Pericas-Geertsen

### Nested Class Summary

Nested Classes
`class` `MultiValuedNodeHeapIterator.HeapNode` An abstract representation of a set of nodes that will be retrieved in document order.

### Field Summary

### Fields inherited from interface org.apache.xml.dtm.DTMAxisIterator

`END`

### Constructor Summary

Constructors
Constructor and Description
`MultiValuedNodeHeapIterator()`

### Method Summary

Methods
`DTMAxisIterator` `cloneIterator()` Returns a deep copy of this iterator.
`void` `gotoMark()` Restores the current node remembered by setMark().
`int` `next()` Get the next node in the iteration.
`DTMAxisIterator` `reset()` Resets the iterator to the last start node.
`void` `setMark()` Remembers the current node for the next call to gotoMark().
`DTMAxisIterator` `setStartNode(int node)` Set start to END should 'close' the iterator, i.e. subsequent call to next() should return END.

### Methods inherited from class org.apache.xml.dtm.ref.DTMAxisIteratorBase

`getAxis, getLast, getNodeByPosition, getPosition, getStartNode, includeSelf, isDocOrdered, isReverse, setRestartable`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### MultiValuedNodeHeapIterator

    public MultiValuedNodeHeapIterator()

### Method Detail

#### cloneIterator

    public DTMAxisIterator cloneIterator()

Description copied from class: `DTMAxisIteratorBase`
Returns a deep copy of this iterator. Cloned iterators may not be restartable. The iterator being cloned may or may not become non-restartable as a side effect of this operation.

Specified by:
  `cloneIterator` in interface `DTMAxisIterator`
Overrides:
  `cloneIterator` in class `DTMAxisIteratorBase`
Returns:
  a deep copy of this iterator.

#### next

    public int next()

Description copied from interface: `DTMAxisIterator`
Get the next node in the iteration.

Returns:
  The next node handle in the iteration, or END.

#### setStartNode

    public DTMAxisIterator setStartNode(int node)

Description copied from interface: `DTMAxisIterator`
Set start to END should 'close' the iterator, i.e. subsequent call to next() should return END.

Parameters:
  `node` - Sets the root of the iteration.
Returns:
  A DTMAxisIterator set to the start of the iteration.

#### setMark

    public void setMark()

Description copied from interface: `DTMAxisIterator`
Remembers the current node for the next call to gotoMark().

#### gotoMark

    public void gotoMark()

Description copied from interface: `DTMAxisIterator`
Restores the current node remembered by setMark().

#### reset

    public DTMAxisIterator reset()

Description copied from interface: `DTMAxisIterator`
Resets the iterator to the last start node.

Specified by:
  `reset` in interface `DTMAxisIterator`
Overrides:
  `reset` in class `DTMAxisIteratorBase`
Returns:
  A DTMAxisIterator which has been reset to the start node, which may or may not be the same as this iterator.